diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java b/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
index 81198680a..14060036b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
@@ -7,59 +7,370 @@ import net.minecraft.core.world.biome.overworld.*;
 import net.minecraft.core.world.biome.drift.BiomeDrift;
 import net.minecraft.core.world.biome.overworld.legacy.*;
 import net.minecraft.core.world.weather.Weathers;
+import org.jetbrains.annotations.NotNull;
 
-public class Biomes
-{
+public class Biomes {
+    public static final @NotNull Biome OVERWORLD_RAINFOREST = register(
+        "minecraft:overworld.rainforest",
+        new BiomeRainforest("overworld.rainforest")
+            .withDebugColor(0x1C_F1_00)
+            .withBlockedWeathers(Weathers.OVERWORLD_SNOW)
+            .withPlacementDefaults(0.975f, 0.925f, 0.5f)
+    );
+    public static final @NotNull Biome OVERWORLD_SWAMPLAND = register(
+        "minecraft:overworld.swampland",
+        new BiomeSwamp("overworld.swampland")
+            .withDebugColor(0x00_FF_78)
+            .withPlacementDefaults(0.85f, 0.925f, 0.5f)
+            .withTags(BiomeTags.HAS_SURFACE_WATER, BiomeTags.HAS_SURFACE_MUD)
+    );
+    public static final @NotNull Biome OVERWORLD_SEASONAL_FOREST = register(
+        "minecraft:overworld.seasonal_forest",
+        new BiomeSeasonalForest("overworld.seasonal_forest")
+            .withDebugColor(0x64_CE_15)
+            .withPlacementDefaults(0.675f, 0.75f, 0.5f)
+    );
+    public static final @NotNull Biome OVERWORLD_FOREST = register(
+        "minecraft:overworld.forest",
+        new BiomeForest("overworld.forest")
+            .withDebugColor(0x26_A6_15)
+            .withPlacementDefaults(0.875f, 0.675f, 0.5f)
+    );
+    public static final @NotNull Biome OVERWORLD_GRASSLANDS = register(
+        "minecraft:overworld.grasslands",
+        new Biome("overworld.grasslands")
+            .withDebugColor(0xF0_F0_48)
+            .withBlockedWeathers(Weathers.OVERWORLD_SNOW)
+            .withPlacementDefaults(0.75f, 0.025f, 0.5f)
+    );
+    public static final @NotNull Biome OVERWORLD_OUTBACK = register(
+        "minecraft:overworld.outback",
+        new BiomeOutback("overworld.outback")
+            .withDebugColor(0xD9_5E_20)
+            .withBlockedWeathers(Weathers.OVERWORLD_SNOW)
+            .withSurfaceProperties(
+                new SurfaceProperties.Builder()
+                    .withTopBlock(Blocks.DIRT_SCORCHED)
+                    .withFillerBlock(Blocks.DIRT_SCORCHED)
+                    .build()
+            )
+            .withPlacementDefaults(0.825f, 0.1f, 0.5f)
+    );
+    public static final @NotNull Biome OVERWORLD_SHRUBLAND = register(
+        "minecraft:overworld.shrubland",
+        new BiomeShrubland("overworld.shrubland")
+            .withDebugColor(0xBA_BA_38)
+            .withPlacementDefaults(0.675f, 0.175f, 0.5f)
+    );
+    public static final @NotNull Biome OVERWORLD_TAIGA = register(
+        "minecraft:overworld.taiga",
+        new BiomeTaiga("overworld.taiga")
+            .withDebugColor(0x8A_BC_FF)
+            .withPlacementDefaults(0.15f, 0.55f, 0.5f)
+            .withTags(BiomeTags.HAS_SURFACE_SNOW, BiomeTags.HAS_SURFACE_ICE)
+    );
+    public static final @NotNull Biome OVERWORLD_BOREAL_FOREST = register(
+        "minecraft:overworld.boreal_forest",
+        new BiomeBorealForest("overworld.boreal_forest")
+            .withDebugColor(0x14_85_64)
+            .withPlacementDefaults(0.4f, 0.525f, 0.5f)
+    );
+    public static final @NotNull Biome OVERWORLD_DESERT = register(
+        "minecraft:overworld.desert",
+        new BiomeDesert("overworld.desert")
+            .withDebugColor(0xED_E2_6F)
+            .withBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM)
+            .withSurfaceProperties(
+                new SurfaceProperties.Builder()
+                    .withTopBlock(Blocks.SAND)
+                    .withFillerBlock(Blocks.SAND)
+                    .build()
+            )
+            .withPlacementDefaults(0.925f, 0.05f, 0.5f)
+    );
+    public static final @NotNull Biome OVERWORLD_PLAINS = register(
+        "minecraft:overworld.plains",
+        new BiomePlains("overworld.plains")
+            .withDebugColor(0xA3_C6_49)
+            .withPlacementDefaults(0.875f, 0.25f, 0.5f)
+    );
+    public static final @NotNull Biome OVERWORLD_GLACIER = register(
+        "minecraft:overworld.glacier",
+        new Biome("overworld.glacier")
+            .withDebugColor(0xCB_F6_FF)
+            .withSurfaceProperties(
+                new SurfaceProperties.Builder()
+                    .withTopBlock(Blocks.BLOCK_SNOW)
+                    .withFillerBlock(Blocks.BLOCK_SNOW)
+                    .build()
+            )
+            .withPlacementDefaults(0.15f, 0.005f, 0.5f)
+            .withTags(BiomeTags.HAS_SURFACE_SNOW, BiomeTags.DEEPER_SNOW)
+    );
+    public static final @NotNull Biome OVERWORLD_TUNDRA = register(
+        "minecraft:overworld.tundra",
+        new Biome("overworld.tundra")
+            .withDebugColor(0x57_E0_FF)
+            .withPlacementDefaults(0.15f, 0.055f, 0.5f)
+            .withTags(BiomeTags.HAS_SURFACE_SNOW, BiomeTags.HAS_SURFACE_ICE)
+    );
+    public static final @NotNull Biome OVERWORLD_MEADOW = register(
+        "minecraft:overworld.meadow",
+        new BiomeBorealForest("overworld.meadow")
+            .withDebugColor(0x8C_8C_22)
+            .withPlacementDefaults(0.4f, 0.025f, 0.5f)
+    );
+    public static final @NotNull Biome OVERWORLD_BIRCH_FOREST = register(
+        "minecraft:overworld.birch_forest",
+        new BiomeBirchForest("overworld.birch_forest")
+            .withDebugColor(0x4B_CB_5E)
+            .withPlacementDefaults(0.675f, 0.4f, 0.5f)
+    );
+    public static final @NotNull Biome OVERWORLD_RETRO = register(
+        "minecraft:overworld.retro",
+        new BiomeRetro("overworld.retro")
+            .withDebugColor(0x76_B1_4A)
+            .withSurfaceProperties(
+                new SurfaceProperties.Builder()
+                    .withTopBlock(Blocks.GRASS_RETRO)
+                    .build()
+            )
+    );
+    public static final @NotNull Biome OVERWORLD_HELL = register(
+        "minecraft:overworld.hell",
+        new Biome("overworld.hell")
+            .withDebugColor(0xD9_62_23)
+            .withSurfaceProperties(
+                new SurfaceProperties.Builder()
+                    .withTopBlock(Blocks.DIRT_SCORCHED)
+                    .withFillerBlock(Blocks.DIRT_SCORCHED)
+                    .build()
+            )
+    );
+    public static final @NotNull Biome OVERWORLD_SWAMPLAND_MUDDY = register(
+        "minecraft:overworld.swampland.muddy",
+        new BiomeSwamp("overworld.swampland.muddy")
+            .withDebugColor(0x52_27_00)
+            .withPlacementDefaults(0.85f, 0.925f, 0.5f)
+            .withTags(BiomeTags.HAS_SURFACE_MUD)
+    );
+    public static final @NotNull Biome OVERWORLD_OUTBACK_GRASSY = register(
+        "minecraft:overworld.outback.grassy",
+        new BiomeOutback("overworld.outback.grassy")
+            .withDebugColor(0xF0_90_37)
+            .withBlockedWeathers(Weathers.OVERWORLD_SNOW)
+            .withSurfaceProperties(
+                new SurfaceProperties.Builder()
+                    .withTopBlock(Blocks.GRASS_SCORCHED)
+                    .withFillerBlock(Blocks.DIRT_SCORCHED)
+                    .build()
+            )
+            .withPlacementDefaults(0.825f, 0.1f, 1.0f)
+    );
+    public static final @NotNull Biome OVERWORLD_CAATINGA = register(
+        "minecraft:overworld.caatinga",
+        new BiomeCaatinga("overworld.caatinga")
+            .withDebugColor(0xDE_CD_A6)
+            .withSurfaceProperties(
+                new SurfaceProperties.Builder()
+                    .withTopBlock(Blocks.MUD_BAKED)
+                    .withFillerBlock(Blocks.MUD_BAKED)
+                    .build()
+            )
+            .withBlockedWeathers(Weathers.OVERWORLD_SNOW)
+            .withPlacementDefaults(0.95f, 0.015f, 0.5f)
+            .withTags(BiomeTags.HAS_SURFACE_MUD)
+    );
+    public static final @NotNull Biome OVERWORLD_CAATINGA_PLAINS = register(
+        "minecraft:overworld.caatinga.plains",
+        new Biome("overworld.caatinga.plains")
+            .withDebugColor(0xA1_94_77)
+            .withSurfaceProperties(
+                new SurfaceProperties.Builder()
+                    .withTopBlock(Blocks.MUD_BAKED)
+                    .withFillerBlock(Blocks.MUD_BAKED)
+                    .build()
+            )
+            .withBlockedWeathers(Weathers.OVERWORLD_SNOW)
+            .withPlacementDefaults(0.95f, 0.015f, 0.0f)
+            .withTags(BiomeTags.HAS_SURFACE_MUD)
+    );
 
-    public static final Biome OVERWORLD_RAINFOREST = register("minecraft:overworld.rainforest", new BiomeRainforest("overworld.rainforest").setColor(0x1cf100).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setDefaults(0.975f, 0.925f, 0.5f));
-    public static final Biome OVERWORLD_SWAMPLAND = register("minecraft:overworld.swampland", new BiomeSwamp("overworld.swampland").setColor(0x00ff78).setDefaults(0.85f, 0.925f, 0.5f));
-    public static final Biome OVERWORLD_SEASONAL_FOREST = register("minecraft:overworld.seasonal_forest", new BiomeSeasonalForest("overworld.seasonal_forest").setColor(0x64ce15).setDefaults(0.675f, 0.75f, 0.5f));
-    public static final Biome OVERWORLD_FOREST = register("minecraft:overworld.forest", new BiomeForest("overworld.forest").setColor(0x26a615).setDefaults(0.875f, 0.675f, 0.5f));
-    public static final Biome OVERWORLD_GRASSLANDS = register("minecraft:overworld.grasslands", new Biome("overworld.grasslands").setColor(0xf0f048).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setDefaults(0.75f, 0.025f, 0.5f));
-    public static final Biome OVERWORLD_OUTBACK = register("minecraft:overworld.outback", new BiomeOutback("overworld.outback").setColor(0xd95e20).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setTopBlock(Blocks.DIRT_SCORCHED.id()).setFillerBlock(Blocks.DIRT_SCORCHED.id()).setDefaults(0.825f, 0.1f, 0.5f));
-    public static final Biome OVERWORLD_SHRUBLAND = register("minecraft:overworld.shrubland", new BiomeShrubland("overworld.shrubland").setColor(0xbaba38).setDefaults(0.675f, 0.175f, 0.5f));
-    public static final Biome OVERWORLD_TAIGA = register("minecraft:overworld.taiga", new BiomeTaiga("overworld.taiga").setColor(0x8abcff).setSurfaceSnow().setSurfaceIce().setDefaults(0.15f, 0.55f, 0.5f));
-    public static final Biome OVERWORLD_BOREAL_FOREST = register("minecraft:overworld.boreal_forest", new BiomeBorealForest("overworld.boreal_forest").setColor(0x148564).setDefaults(0.4f, 0.525f, 0.5f));
-    public static final Biome OVERWORLD_DESERT = register("minecraft:overworld.desert", new BiomeDesert("overworld.desert").setColor(0xEDE26F).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM).setTopBlock(Blocks.SAND.id()).setFillerBlock(Blocks.SAND.id()).setDefaults(0.925f, 0.05f, 0.5f));
-    public static final Biome OVERWORLD_PLAINS = register("minecraft:overworld.plains", new BiomePlains("overworld.plains").setColor(0xA3C649).setDefaults(0.875f, 0.25f, 0.5f));
-    public static final Biome OVERWORLD_GLACIER = register("minecraft:overworld.glacier", new Biome("overworld.glacier").setColor(0xcbf6ff).setSurfaceSnow().setTopBlock(Blocks.BLOCK_SNOW.id()).setFillerBlock(Blocks.BLOCK_SNOW.id()).setDefaults(0.15f, 0.005f, 0.5f));
-    public static final Biome OVERWORLD_TUNDRA = register("minecraft:overworld.tundra", new Biome("overworld.tundra").setColor(0x57e0ff).setSurfaceSnow().setSurfaceIce().setDefaults(0.15f, 0.055f, 0.5f));
-    public static final Biome OVERWORLD_MEADOW = register("minecraft:overworld.meadow", new BiomeBorealForest("overworld.meadow").setColor(0x8c8c22).setDefaults(0.4f, 0.025f, 0.5f));
-    public static final Biome DRIFT_DRIFT = register("minecraft:drift.drift", new BiomeDrift("drift.drift").setColor(0x8080FF).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setDefaults(0.5f, 0.0f, 0.0f));
-    public static final Biome OVERWORLD_BIRCH_FOREST = register("minecraft:overworld.birch_forest", new BiomeBirchForest("overworld.birch_forest").setColor(0x4bcb5e).setDefaults(0.675f, 0.4f, 0.5f));
-    public static final Biome OVERWORLD_RETRO = register("minecraft:overworld.retro", new BiomeRetro("overworld.retro").setColor(0x76B14A).setTopBlock(Blocks.GRASS_RETRO.id()));
-    public static final Biome OVERWORLD_HELL = register("minecraft:overworld.hell", new Biome("overworld.hell").setColor(0xD96223).setTopBlock(Blocks.DIRT_SCORCHED.id()).setTopBlock(Blocks.DIRT_SCORCHED.id()));
-    public static final Biome OVERWORLD_SWAMPLAND_MUDDY = register("minecraft:overworld.swampland.muddy", new BiomeSwamp("overworld.swampland.muddy").setColor(0x522700).setDefaults(0.85f, 0.925f, 0.5f));
-    public static final Biome OVERWORLD_OUTBACK_GRASSY = register("minecraft:overworld.outback.grassy", new BiomeOutback("overworld.outback.grassy").setColor(0xf09037).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setTopBlock(Blocks.GRASS_SCORCHED.id()).setFillerBlock(Blocks.DIRT_SCORCHED.id()).setDefaults(0.825f, 0.1f, 1.0f));
-    public static final Biome OVERWORLD_CAATINGA = register("minecraft:overworld.caatinga", new BiomeCaatinga("overworld.caatinga").setColor(0xdecda6).setTopBlock(Blocks.MUD_BAKED.id()).setFillerBlock(Blocks.MUD_BAKED.id()).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setDefaults(0.95f, 0.015f, 0.5f));
-    public static final Biome OVERWORLD_CAATINGA_PLAINS = register("minecraft:overworld.caatinga.plains", new Biome("overworld.caatinga.plains").setColor(0xa19477).setTopBlock(Blocks.MUD_BAKED.id()).setFillerBlock(Blocks.MUD_BAKED.id()).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setDefaults(0.95f, 0.015f, 0.0f));
+    public static final @NotNull Biome NETHER_CRAG = register(
+        "minecraft:nether.crag",
+        new BiomeNether("nether.crag")
+            .withDebugColor(0x63_3E_3D)
+            .withBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG)
+            .withSurfaceProperties(
+                new SurfaceProperties.Builder()
+                    .withTopBlock(Blocks.COBBLE_NETHERRACK)
+                    .withFillerBlock(Blocks.COBBLE_NETHERRACK)
+                    .build()
+            )
+    );
+    public static final @NotNull Biome NETHER_VOLCANIC_ISLANDS = register(
+        "minecraft:nether.volcanic_islands",
+        new BiomeVolcanoIslands("nether.volcanic_islands")
+            .withDebugColor(0xFF_A3_33)
+            .withBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG)
+            .withSurfaceProperties(
+                new SurfaceProperties.Builder()
+                    .withTopBlock(Blocks.BRIMSAND)
+                    .withFillerBlock(Blocks.BRIMSAND)
+                    .build()
+            )
+    );
+    public static final @NotNull Biome NETHER_SULFUR_POOLS = register(
+        "minecraft:nether.sulfur_pools",
+        new BiomeSulfurPools("nether.sulfur_pools")
+            .withDebugColor(0xA3_99_40)
+            .withBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG)
+            .withSurfaceProperties(
+                new SurfaceProperties.Builder()
+                    .withTopBlock(Blocks.BRIMSAND)
+                    .withFillerBlock(Blocks.BRIMSAND)
+                    .build()
+            )
+            .withTags(BiomeTags.HAS_SULFUR_POOLS)
+    );
+    public static final @NotNull Biome NETHER_CRYSTAL_PLAINS = register(
+        "minecraft:nether.crystal_plains",
+        new BiomeCrystalForest("nether.crystal_plains")
+            .withDebugColor(0xAA_00_00)
+            .withBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG)
+            .withSurfaceProperties(
+                new SurfaceProperties.Builder()
+                    .withTopBlock(Blocks.COBBLE_NETHERRACK)
+                    .withFillerBlock(Blocks.COBBLE_NETHERRACK)
+                    .build()
+            )
+            .withTags(BiomeTags.HAS_CRYSTAL_VEINS)
+    );
+    public static final @NotNull Biome NETHER_CRYSTAL_FOREST = register(
+        "minecraft:nether.crystal_forest",
+        new BiomeCrystalForest("nether.crystal_forest")
+            .withDebugColor(0xDD_00_00)
+            .withBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG)
+            .withSurfaceProperties(
+                new SurfaceProperties.Builder()
+                    .withTopBlock(Blocks.COBBLE_NETHERRACK)
+                    .withFillerBlock(Blocks.COBBLE_NETHERRACK)
+                    .build()
+            )
+            .withTags(BiomeTags.HAS_CRYSTAL_VEINS)
+    );
+    public static final @NotNull Biome NETHER_OLD_WORLD = register(
+        "minecraft:nether.old_world",
+        new BiomeNether("nether.old_world")
+            .withDebugColor(0x63_64_80)
+            .withBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG)
+            .withSurfaceProperties(
+                new SurfaceProperties.Builder()
+                    .withTopBlock(Blocks.COBBLE_NETHERRACK)
+                    .withFillerBlock(Blocks.COBBLE_NETHERRACK)
+                    .build()
+            )
+            .withTags(BiomeTags.HAS_SURFACE_ASH)
+    );
+    public static final @NotNull Biome NETHER_SHELF = register(
+        "minecraft:nether.shelf",
+        new BiomeNether("nether.shelf")
+            .withDebugColor(0x96_8A_6F)
+            .withBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG)
+            .withSurfaceProperties(
+                new SurfaceProperties.Builder()
+                    .withTopBlock(Blocks.COBBLE_NETHERRACK)
+                    .withFillerBlock(Blocks.COBBLE_NETHERRACK)
+                    .build()
+            )
+    );
 
-    public static final Biome NETHER_CRAG = register("minecraft:nether.crag", new BiomeNether("nether.crag").setColor(0x633e3d).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.COBBLE_NETHERRACK.id()).setFillerBlock(Blocks.COBBLE_NETHERRACK.id()));
-    public static final Biome NETHER_VOLCANIC_ISLANDS = register("minecraft:nether.volcanic_islands", new BiomeVolcanoIslands("nether.volcanic_islands").setColor(0xffa333).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.BRIMSAND.id()).setFillerBlock(Blocks.BRIMSAND.id()));
-    public static final Biome NETHER_SULFUR_POOLS = register("minecraft:nether.sulfur_pools", new BiomeSulfurPools("nether.sulfur_pools").setColor(0xa39940).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.BRIMSAND.id()).setFillerBlock(Blocks.BRIMSAND.id()));
-    public static final Biome NETHER_CRYSTAL_FIELD = register("minecraft:nether.crystal_field", new BiomeCrystalForest("nether.crystal_field").setColor(0xAA0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.COBBLE_NETHERRACK.id()).setFillerBlock(Blocks.COBBLE_NETHERRACK.id()));
-    public static final Biome NETHER_CRYSTAL_FOREST = register("minecraft:nether.crystal_forest", new BiomeCrystalForest("nether.crystal_forest").setColor(0xDD0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.COBBLE_NETHERRACK.id()).setFillerBlock(Blocks.COBBLE_NETHERRACK.id()));
-    public static final Biome NETHER_OLD_WORLD = register("minecraft:nether.old_world", new BiomeNether("nether.old_world").setColor(0x636480).setSurfaceSnow().setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.COBBLE_NETHERRACK.id()).setFillerBlock(Blocks.COBBLE_NETHERRACK.id()));
-    public static final Biome NETHER_SHELF = register("minecraft:nether.shelf", new BiomeNether("nether.shelf").setColor(0x968a6f).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.COBBLE_NETHERRACK.id()).setFillerBlock(Blocks.COBBLE_NETHERRACK.id()));
+    public static final @NotNull Biome DRIFT_DRIFT = register(
+        "minecraft:drift.drift",
+        new BiomeDrift("drift.drift")
+            .withDebugColor(0x80_80_FF)
+            .withBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG)
+            .withPlacementDefaults(0.5f, 0.0f, 0.0f)
+    );
 
-    public static final Biome OVERWORLD_LEGACY_RAINFOREST = register("minecraft:overworld.legacy.rainforest", new BiomeRainforestLegacy("overworld.legacy.rainforest").setColor(0xd9e023).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setDefaults(0.985f,  0.95f, 0.5f));
-    public static final Biome OVERWORLD_LEGACY_SWAMPLAND = register("minecraft:overworld.legacy.swampland", new BiomeSwampLegacy("overworld.legacy.swampland").setColor(0x07f9b2).setDefaults(0.75f, 0.4f, 0.5f));
-    public static final Biome OVERWORLD_LEGACY_SEASONAL_FOREST = register("minecraft:overworld.legacy.seasonal_forest", new Biome("overworld.legacy.seasonal_forest").setColor(0x9be023).setDefaults(0.985f, 0.675f, 0.5f));
-    public static final Biome OVERWORLD_LEGACY_FOREST = register("minecraft:overworld.legacy.forest", new BiomeForestLegacy("overworld.legacy.forest").setColor(0x056621).setDefaults(0.735f, 0.425f, 0.5f));
-    public static final Biome OVERWORLD_LEGACY_SAVANNA = register("minecraft:overworld.legacy.savanna", new BiomeDesertLegacy("overworld.legacy.savanna").setColor(0xd9e023).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setDefaults(0.725f, 0.1f, 0.5f));
-    public static final Biome OVERWORLD_LEGACY_SHRUBLAND = register("minecraft:overworld.legacy.shrubland", new Biome("overworld.legacy.shrubland").setColor(0xa1ad20).setDefaults(0.735f, 0.275f, 0.5f));
-    public static final Biome OVERWORLD_LEGACY_TAIGA = register("minecraft:overworld.legacy.taiga", new BiomeTaigaLegacy("overworld.legacy.taiga").setColor(0x2eb153).setSurfaceSnow().setSurfaceIce().setDefaults(0.3f, 0.35f, 0.5f));
-    public static final Biome OVERWORLD_LEGACY_DESERT = register("minecraft:overworld.legacy.desert", new BiomeDesertLegacy("overworld.legacy.desert").setColor(0xfa9418).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM).setTopBlock(Blocks.SAND.id()).setFillerBlock(Blocks.SAND.id()).setDefaults(0.975f, 0.1f, 0.5f));
-    public static final Biome OVERWORLD_LEGACY_PLAINS = register("minecraft:overworld.legacy.plains", new BiomeDesertLegacy("overworld.legacy.plains").setColor(0xffd910).setDefaults(0.985f, 0.325f, 0.5f));
-    public static final Biome OVERWORLD_LEGACY_TUNDRA = register("minecraft:overworld.legacy.tundra", new Biome("overworld.legacy.tundra").setColor(0x57ebf9).setSurfaceSnow().setSurfaceIce().setDefaults(0.05f, 0.5f, 0.5f));
+    public static final @NotNull Biome OVERWORLD_LEGACY_RAINFOREST = register(
+        "minecraft:overworld.legacy.rainforest",
+        new BiomeRainforestLegacy("overworld.legacy.rainforest")
+            .withDebugColor(0xD9_E0_23)
+            .withBlockedWeathers(Weathers.OVERWORLD_SNOW)
+            .withPlacementDefaults(0.985f, 0.95f, 0.5f)
+    );
+    public static final @NotNull Biome OVERWORLD_LEGACY_SWAMPLAND = register(
+        "minecraft:overworld.legacy.swampland",
+        new BiomeSwampLegacy("overworld.legacy.swampland")
+            .withDebugColor(0x07_F9_B2)
+            .withPlacementDefaults(0.75f, 0.4f, 0.5f)
+    );
+    public static final @NotNull Biome OVERWORLD_LEGACY_SEASONAL_FOREST = register(
+        "minecraft:overworld.legacy.seasonal_forest",
+        new Biome("overworld.legacy.seasonal_forest")
+            .withDebugColor(0x9B_E0_23)
+            .withPlacementDefaults(0.985f, 0.675f, 0.5f)
+    );
+    public static final @NotNull Biome OVERWORLD_LEGACY_FOREST = register(
+        "minecraft:overworld.legacy.forest",
+        new BiomeForestLegacy("overworld.legacy.forest")
+            .withDebugColor(0x05_66_21)
+            .withPlacementDefaults(0.735f, 0.425f, 0.5f)
+    );
+    public static final @NotNull Biome OVERWORLD_LEGACY_SAVANNA = register(
+        "minecraft:overworld.legacy.savanna",
+        new BiomeDesertLegacy("overworld.legacy.savanna")
+            .withDebugColor(0xD9_E0_23)
+            .withBlockedWeathers(Weathers.OVERWORLD_SNOW)
+            .withPlacementDefaults(0.725f, 0.1f, 0.5f)
+    );
+    public static final @NotNull Biome OVERWORLD_LEGACY_SHRUBLAND = register(
+        "minecraft:overworld.legacy.shrubland",
+        new Biome("overworld.legacy.shrubland")
+            .withDebugColor(0xA1_AD_20)
+            .withPlacementDefaults(0.735f, 0.275f, 0.5f)
+    );
+    public static final @NotNull Biome OVERWORLD_LEGACY_TAIGA = register(
+        "minecraft:overworld.legacy.taiga",
+        new BiomeTaigaLegacy("overworld.legacy.taiga")
+            .withDebugColor(0x2E_B1_53)
+            .withPlacementDefaults(0.3f, 0.35f, 0.5f)
+            .withTags(BiomeTags.HAS_SURFACE_SNOW, BiomeTags.HAS_SURFACE_ICE)
+    );
+    public static final @NotNull Biome OVERWORLD_LEGACY_DESERT = register(
+        "minecraft:overworld.legacy.desert",
+        new BiomeDesertLegacy("overworld.legacy.desert")
+            .withDebugColor(0xFA_94_18)
+            .withBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM)
+            .withSurfaceProperties(
+                new SurfaceProperties.Builder()
+                    .withTopBlock(Blocks.SAND)
+                    .withFillerBlock(Blocks.SAND)
+                    .build()
+            )
+            .withPlacementDefaults(0.975f, 0.1f, 0.5f)
+    );
+    public static final @NotNull Biome OVERWORLD_LEGACY_PLAINS = register(
+        "minecraft:overworld.legacy.plains",
+        new BiomeDesertLegacy("overworld.legacy.plains")
+            .withDebugColor(0xFF_D9_10)
+            .withPlacementDefaults(0.985f, 0.325f, 0.5f)
+    );
+    public static final @NotNull Biome OVERWORLD_LEGACY_TUNDRA = register(
+        "minecraft:overworld.legacy.tundra",
+        new Biome("overworld.legacy.tundra")
+            .withDebugColor(0x57_EB_F9)
+            .withPlacementDefaults(0.05f, 0.5f, 0.5f)
+            .withTags(BiomeTags.HAS_SURFACE_SNOW, BiomeTags.HAS_SURFACE_ICE)
+    );
 
-    public static Biome register(String key, Biome biome)
-    {
+    public static @NotNull Biome register(final @NotNull String key, final @NotNull Biome biome) {
         Registries.BIOMES.register(key, biome);
-
         return biome;
     }
 
-    public static void init() { }
+    public static void init() {
+    }
 
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/SurfaceProperties.java b/game/core/src/main/java/net/minecraft/core/world/biome/SurfaceProperties.java
new file mode 100644
index 000000000..89673a124
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/SurfaceProperties.java
@@ -0,0 +1,56 @@
+package net.minecraft.core.world.biome;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import org.jetbrains.annotations.NotNull;
+
+public final class SurfaceProperties {
+    private final @NotNull Block<?> topBlock;
+    private final @NotNull Block<?> fillerBlock;
+
+    private SurfaceProperties(
+        final @NotNull Block<?> topBlock,
+        final @NotNull Block<?> fillerBlock
+    ) {
+        this.topBlock = topBlock;
+        this.fillerBlock = fillerBlock;
+    }
+
+    public @NotNull Block<?> getTopBlock() {
+        return this.topBlock;
+    }
+
+    public @NotNull Block<?> getFillerBlock() {
+        return this.fillerBlock;
+    }
+
+    public static final class Builder {
+        private @NotNull Block<?> topBlock = Blocks.GRASS;
+        private @NotNull Block<?> fillerBlock = Blocks.DIRT;
+
+        public @NotNull Block<?> getTopBlock() {
+            return this.topBlock;
+        }
+
+        public @NotNull Builder withTopBlock(final @NotNull Block<?> block) {
+            this.topBlock = block;
+            return this;
+        }
+
+        public @NotNull Block<?> getFillerBlock() {
+            return this.fillerBlock;
+        }
+
+        public @NotNull Builder withFillerBlock(final @NotNull Block<?> block) {
+            this.fillerBlock = block;
+            return this;
+        }
+
+        public @NotNull SurfaceProperties build() {
+            return new SurfaceProperties(
+                this.topBlock,
+                this.fillerBlock
+            );
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeBirchForest.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeBirchForest.java
index 13acfed9c..899bf0c01 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeBirchForest.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeBirchForest.java
@@ -4,9 +4,10 @@ import net.minecraft.core.entity.animal.MobWolf;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.SpawnListEntry;
 import net.minecraft.core.world.biome.Biome;
-import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.WorldFeature;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeTall;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -20,7 +21,7 @@ public class BiomeBirchForest extends Biome
     }
 
     @Override
-	public WorldFeature getRandomWorldGenForTrees(Random random)
+	public @NotNull WorldFeature getTreeFeature(@NotNull Random random)
     {
 
         if(random.nextInt(10) == 0)
